\section{Can we isolate Hidden Service circuits?}\label{sec:iso}

Another approach to protect the regular users of the Tor network from
resource depletion by a hidden-service botnet would be to isolate hidden
service onion-skin processing from ordinary processing.  By
introducing a mechanism that allows relays to recognize that an {\sc
  extend} or {\sc create} cell is likely to  carry hidden service
traffic, we could provide a means to protect the rest of the system
from the effects of this traffic, by scheduling priority or simple isolation.   

An example of how this might work in practice is to introduce new {\sc
  nohs-extend}/{\sc nohs-create} cell types with the rule that a
circuit that is created with an {\sc nohs-create} cell will silently
drop a normal {\sc extend} cell, or any of the cell types associated
with hidden services.  If relays also silently drop {\sc nohs-extend}
cells on circuits created with ordinary {\sc create} cells, then {\sc
  nohs-create} circuits are guaranteed not to carry hidden service
traffic.  Updated clients would then create all circuits with {\sc
  nohs-create} unless connecting to a hidden service.  When a
sufficient number of clients and relays update their Tor version, a
consensus flag could be used to signal relays to begin isolating
processing of ordinary {\sc create} cells.  For example, these cells
might only be processed in the last 20ms of each 100ms period, leaving
80\% of processing capacity available for regular traffic.  The flag
could be triggered when hidden service circuits exceed a significant
fraction of all circuits in the network.\footnote{Detecting this
  condition in a privacy-preserving manner represents another
  technical challenge requiring further research.}

This solution protects the network and typical users from a massive
botnet hidden service, but would, unfortunately, intensify the effect
on users of legitimate hidden services in time periods when an attack
was detected.  As with guard throttling, the intended effect would
thus be to encourage botmasters to develop C\&C channels that do not
stress the Tor hidden service ecosystem, while providing stronger
protection against botnet clients flooding the network.  

One privacy concern related to this approach is that as the network
upgrades to versions of Tor supporting {\sc nohs-create},
identification of hidden-service traffic approaches deterministic
certainty.  By contrast, current hidden service circuits follow
traffic patterns that allow them to be identified with high
statistical confidence~\cite{oakland2013-trawling} only.  Because
(excluding botnet traffic) the base rates of hidden service traffic
compared to all other traffic are low, this will also decrease the privacy
of hidden service users.  One potential mitigation mechanism would be
to have clients only use {\sc nohs-create} when the
consensus flag for hidden service isolation is activated,  which would
indicate that hidden service clients would already have a large anonymity
set.


%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "botnet-tr"
%%% End: 
